import { j as o } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as Q, useModal as U, antdModalV5 as X } from "@ebay/nice-modal-react";
import { theme as Y, Modal as Z, Checkbox as _, Button as $ } from "antd";
import a from "./index.module.less.mjs";
import { useState as g, useContext as L, useEffect as ss, useCallback as B, useMemo as f } from "react";
import { TableContext as es } from "../../Store/index.mjs";
import { genColumnKey as T, columnSort as os } from "../../Store/utils/index.mjs";
import ls from "../../../../node_modules/classnames/index.mjs";
import { DndContext as ts } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as ns, verticalListSortingStrategy as as, arrayMove as cs } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import is from "./DndItem.mjs";
import { restrictToVerticalAxis as rs, restrictToWindowEdges as ms } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import R from "../../../BitzButton/index.mjs";
import "./index.less.mjs";
import { useImmer as ds } from "../../../../node_modules/use-immer/dist/use-immer.module.mjs";
import z from "../../../../node_modules/lodash-es/omit.mjs";
import us from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import ps from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
const Bs = Q(() => {
  var w;
  Y.useToken();
  const h = U(), [u, j] = g(null), [A, k] = g(!1), [c, x] = ds({
    columnsMap: {},
    sortKeyColumns: []
  }), {
    persistenceType: O,
    persistenceKey: v,
    onlineChange: M,
    columnsMap: V,
    setColumnsMap: F,
    sortKeyColumns: W,
    setSortKeyColumns: q,
    // clearPersistenceStorage,
    ...l
  } = L(es);
  ss(() => {
    x((s) => {
      s.columnsMap = { ...V }, s.sortKeyColumns = [...W];
    });
  }, []);
  const G = B(() => {
    x((s) => {
      s.columnsMap = { ...l.defaultColumnKeyMap };
    });
  }, []), p = f(() => {
    var e, t;
    const s = [];
    return (e = l == null ? void 0 : l.columns) != null && e.length && ((t = l == null ? void 0 : l.columns) == null || t.map(({ key: d, dataIndex: n, ...r }) => {
      const y = T(
        d || n,
        [d || n].filter(Boolean).join("-")
      ), m = c.columnsMap[y || "null"];
      return (m == null ? void 0 : m.show) !== !1 && s.push({
        key: y,
        ...z(r, ["className"]),
        selectable: !1,
        disabled: (m == null ? void 0 : m.disable) === !0
      }), m;
    })), s.sort(os(c.columnsMap));
  }, [c.columnsMap, l == null ? void 0 : l.columns]), b = B(
    (s) => {
      var e;
      return (e = c.sortKeyColumns) == null ? void 0 : e.findIndex((t) => t === s);
    },
    [c.sortKeyColumns]
  ), N = f(
    () => u ? b(u) : -1,
    [u, b]
  ), K = f(() => {
    const s = [], e = /* @__PURE__ */ new Map();
    return { list: ((d, n) => d.map(({ key: r, dataIndex: y, children: m, ...D }) => {
      var E;
      const C = T(
        r || y,
        [n == null ? void 0 : n.columnKey, D.index].filter(Boolean).join("-")
      ), i = c.columnsMap[C || "null"] || { show: !0 };
      (i == null ? void 0 : i.show) !== !1 && !m && s.push(C);
      const I = {
        key: C,
        ...z(D, ["className"]),
        selectable: !1,
        disabled: i.disable === !0,
        disableCheckbox: typeof i.disable == "boolean" ? i == null ? void 0 : i.disable : (E = i == null ? void 0 : i.disable) == null ? void 0 : E.checkbox,
        isLeaf: n ? !0 : void 0
      };
      return e.set(r, I), I;
    }))(l == null ? void 0 : l.columns), keys: s, map: e };
  }, [c.columnsMap, l == null ? void 0 : l.columns]), H = (s, e) => {
    const t = { ...c.columnsMap };
    ((n) => {
      const r = { ...t[n] };
      r.show = !s, t[n] = r;
    })(e.key), k(!0), x((n) => {
      n.columnsMap = { ...t };
    });
  }, J = (s, e) => {
    const t = { ...c.columnsMap }, d = cs(c.sortKeyColumns, s, e);
    d.forEach((n, r) => {
      t[n] = { ...t[n] || {}, order: r };
    }), k(!0), x((n) => {
      n.columnsMap = { ...t }, n.sortKeyColumns = d;
    });
  };
  f(() => {
    var s, e;
    return u ? ((e = (s = l == null ? void 0 : l.columns) == null ? void 0 : s.find((t) => t.key === u)) == null ? void 0 : e.title) ?? "" : "";
  }, [l == null ? void 0 : l.columns, u]);
  const P = () => {
    F(c.columnsMap), q(c.sortKeyColumns), O === "online" && v && (M == null || M(v, c.columnsMap)), h.resolve({ ...c.columnsMap }), h.hide();
  }, S = () => {
    h.hide();
  };
  return /* @__PURE__ */ o.jsxs(
    Z,
    {
      className: "tableColumnSettingModal",
      title: "自定义列",
      ...X(h),
      width: 600,
      onCancel: S,
      footer: /* @__PURE__ */ o.jsxs(o.Fragment, { children: [
        /* @__PURE__ */ o.jsx(
          R,
          {
            type: "primary",
            icon: /* @__PURE__ */ o.jsx(us, {}),
            onClick: P,
            disabled: !A,
            children: "保存"
          }
        ),
        /* @__PURE__ */ o.jsx(R, { onClick: S, children: "取消" })
      ] }),
      children: [
        /* @__PURE__ */ o.jsx("div", { className: a.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ o.jsxs("div", { className: a.container, children: [
          /* @__PURE__ */ o.jsxs("div", { className: a.block, children: [
            /* @__PURE__ */ o.jsxs("div", { className: a.header, children: [
              /* @__PURE__ */ o.jsx("div", { className: a.title, children: "可用列" }),
              /* @__PURE__ */ o.jsx("div", {})
            ] }),
            /* @__PURE__ */ o.jsx("div", { className: a.body, children: /* @__PURE__ */ o.jsx("ul", { className: a.content, children: (w = K.list) == null ? void 0 : w.map((s) => {
              const e = K.keys.includes(s.key);
              return /* @__PURE__ */ o.jsxs(
                "li",
                {
                  className: ls(a.item, {
                    [a.checked]: !e
                  }),
                  onClick: () => !s.disabled && H(e, s),
                  children: [
                    /* @__PURE__ */ o.jsx(_, { checked: e, disabled: s.disabled }),
                    /* @__PURE__ */ o.jsx("span", { className: a["content-item-text"], children: s.title })
                  ]
                },
                s.key
              );
            }) }) })
          ] }),
          /* @__PURE__ */ o.jsxs("div", { className: a.block, children: [
            /* @__PURE__ */ o.jsxs("div", { className: a.header, children: [
              /* @__PURE__ */ o.jsx("div", { className: a.title, children: "选定列" }),
              /* @__PURE__ */ o.jsx(
                $,
                {
                  type: "link",
                  icon: /* @__PURE__ */ o.jsx(ps, {}),
                  size: "small",
                  onClick: G,
                  children: "重置"
                }
              )
            ] }),
            /* @__PURE__ */ o.jsx("div", { className: a.body, children: /* @__PURE__ */ o.jsx(
              ts,
              {
                modifiers: [rs, ms],
                onDragStart: (s) => {
                  const { active: e } = s;
                  e && j(e == null ? void 0 : e.id);
                },
                onDragCancel: () => j(null),
                onDragEnd: (s) => {
                  j(null);
                  const { over: e } = s;
                  if (e) {
                    const t = b(e.id);
                    N !== t && J(N, t);
                  }
                },
                children: /* @__PURE__ */ o.jsx(
                  ns,
                  {
                    items: p == null ? void 0 : p.map((s) => s.key),
                    strategy: as,
                    children: /* @__PURE__ */ o.jsx("ul", { className: a.content, style: { background: "#fff" }, children: p == null ? void 0 : p.map((s) => /* @__PURE__ */ o.jsx(is, { item: s }, s.key)) })
                  }
                )
              }
            ) })
          ] })
        ] })
      ]
    }
  );
});
export {
  Bs as default
};
